package simulation;
import display.*;

public class Test {
	
	public static int tailleEchantillon = 30000;
	
	public static void main(String[] args){
		int test = 0;
		switch (test) {
		case 0: testVAUniformeContinue01(); break;
		case 1: testVecteurUniformeContinue01(); break;
		case 2: testVAUniformeContinue();break;
		case 3: testVABernouilli();break;
		case 4: testVABinomiale();break;
		case 5: testVAUniformeDiscrete();break;
		case 6: testVAFinie();break;
		case 7: testVAExponentielle();break;
		case 8: testVAPoisson();break;
		case 9: testVAGeometrique(); break;
		default:break;
		}
	}
	
	private static void testVecteurUniformeContinue01() {
		VariableAleatoireContinue x = new VariableAleatoireUniformeContinue01();
		double[] xx = x.echantillon(tailleEchantillon);
		Graph3d g = new Graph3d(xx);
		g.display();		
	}

	private static void testVAUniformeContinue01() {
		VariableAleatoireContinue va = new VariableAleatoireUniformeContinue01();
		va.setFrequence(true);
		va.setTailleIntervalles(0.02);
		va.test(tailleEchantillon);
	}

	private static void testVAUniformeContinue() {
		int min =-1;
		int max = 2;
		VariableAleatoireContinue va = new VariableAleatoireUniformeContinue(min,max);
		va.setFrequence(true);
		va.setTailleIntervalles(0.2);
		va.test(tailleEchantillon);
	}

	private static void testVABernouilli() {
		VariableAleatoireDiscrete va = new VariableAleatoireBernoulli(0.3);
		va.setFrequence(true);
		va.test(tailleEchantillon);		
	}
	
	private static void testVABinomiale() {
		VariableAleatoireDiscrete va = new VariableAleatoireBinomiale(30,0.3);
		va.setFrequence(true);
		va.test(tailleEchantillon);
	}

	private static void testVAUniformeDiscrete() {
		int min =-1;
		int max = 2;
		VariableAleatoireDiscrete va = new VariableAleatoireUniformeDiscrete(min,max);
		va.setFrequence(true);
		va.test(tailleEchantillon);
	}
	
	private static void testVAFinie(){
		int[] vals = {-1,1,2,3,4};
		double[] pbs = {0.02,0.08,0.4,0.2,0.3};
		VariableAleatoireDiscrete va = new VariableAleatoireFinie(vals,pbs);
		va.setFrequence(false);
		va.test(tailleEchantillon);
	}
	
	private static void testVAExponentielle() {
		double lambda = 0.9;
		VariableAleatoireContinue va = new VariableAleatoireExponentielle(lambda);
		va.setFrequence(false);
		va.setTailleIntervalles(0.4);
		va.test(tailleEchantillon);		
	}

	private static void testVAPoisson() {
		int lambda = 9;
		VariableAleatoireDiscrete va = new VariableAleatoirePoisson(lambda);
		va.setFrequence(false);
		va.test(tailleEchantillon);
	}

	private static void testVAGeometrique() {
		VariableAleatoireDiscrete va = new VariableAleatoireGeometrique(0.2);
		va.setFrequence(false);
		va.test(tailleEchantillon);
	}	
}
