package simulation;
import laws.*;
import display.*;

public abstract class VariableAleatoireContinue {
	/* Engendre une observation de la variable alatoire. */
	public abstract double observation();
	
	/* Gnre un chantillon de taille n de la variable alatoire. */	
	public final double[] echantillon(int n){
		double[] res = new double[n];
		for(int i=0;i<n;i++)
			res[i] = observation();
		return res;
	}
	
	/* Indique s'il faut afficher la frquence ou les occurences dans les tests */
	protected boolean frequence = false;
	public final void setFrequence(boolean frequence){ this.frequence = frequence; }
	
	/* Ajuste la taille des intervalles pour l'affichage des histogrammes */
	protected double tailleIntervalles = 1;
	public final void setTailleIntervalles(double tailleIntervalles){ 
		this.tailleIntervalles = tailleIntervalles; 
	}
	
	/* Teste le simulateur avec un chantillon de taille n 
	 * Retourne l'chantillon gnr 						*/
	public final double[] test(int n) { 
		double[] echantillon = echantillon(n);
		Plot h = new Plot(echantillon,"Test "+toString(), 
						tailleIntervalles, frequence, loi);
		h.display();
		return echantillon;
	}
	
	/*
	 * Retourne la Loi de la variable alatoire
	 */
	protected Loi loi;
	
	public abstract String toString();
}
