package simulation;
import laws.*;
import display.*;

public abstract class VariableAleatoireDiscrete {
	/* Engendre une observation de la variable alatoire. */
	public abstract int observation();
	
	/* Gnre un chantillon de taille n de la variable alatoire. */	
	public final int[] echantillon(int n){
		int[] res = new int[n];
		for(int i=0;i<n;i++)
			res[i] = observation();
		return res;
	}
	
	/* Indique s'il faut afficher la frquence ou les occurences dans les tests */
	protected boolean frequence = false;
	public final void setFrequence(boolean frequence){ this.frequence = frequence; }

	/* Teste le simulateur avec un chantillon de taille n 
	 * Retourne l'chantillon gnr 						*/
	public final int[] test(int n) { 
		int[] echantillon = echantillon(n);
		Plot h = new Plot(echantillon,"Test "+toString(), frequence, loi);
		h.display();
		return echantillon;
	}
	
	/*
	 * Retourne la Loi de la variable alatoire
	 */
	protected Loi loi;

	public abstract String toString();
}
