package simulation;
import laws.*;

public class VariableAleatoireFinie extends VariableAleatoireDiscrete{
	int[] valeur;
	double[] proba;
	
	public VariableAleatoireFinie(int[] values, double[] probas){
		if(values.length!=probas.length) throw new IllegalArgumentException("La liste de valeurs doit comporter autant d'lment que la liste de probabilits.");
		double total = 0;
		for(double d:probas) total+=d;
		if(total!=1) throw new IllegalArgumentException("La somme des probabilits doit tre gale  1.");
		valeur = new int[values.length];
		proba = new double[probas.length];
		for(int i=0;i<values.length;i++){
			valeur[i] = values[i];
			proba[i] = probas[i];
		}
		this.loi = new Finie(values,probas);
	}

	public String toString(){ return "Simulation v.a. de prob. disc. sur un ensemble fini"; }
	
	public int observation() {
		/**
		 * A COMPLETER
		 */
		return -1;
	}
	
}
